unit owex001_Unit1;

interface

uses
  ole_word,
  ole_word_const,

  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.Buttons, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Panel2: TPanel;
    Label1: TLabel;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    Panel3: TPanel;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    Panel4: TPanel;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    SpeedButton10: TSpeedButton;
    OpenDialog1: TOpenDialog;
    Panel5: TPanel;
    Label2: TLabel;
    Label_DocFN: TLabel;
    SaveDialog1: TSaveDialog;
    Panel6: TPanel;
    SpeedButton7: TSpeedButton;
    RadioGroup_FormatDoc: TRadioGroup;
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    vWord:variant; //  MS Word
    vDoc:variant;  //   MS Word
    fnDoc:string; //   
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}




procedure TForm1.FormCreate(Sender: TObject);
begin
  OpenDialog1.InitialDir:=ExtractFilePath(ParamStr(0));
  SaveDialog1.InitialDir:=OpenDialog1.InitialDir;
end;

procedure TForm1.SpeedButton10Click(Sender: TObject);
begin
  ShowMessage(Word_Version(vWord));
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  Word_Quit(vWord, true); //   "" -    MS Word (   )
  fnDoc:='';
  Label_DocFN.Caption:=fnDoc;
  vWord := Word_Open(false);
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  Word_Quit(vWord, true);
  fnDoc:='';
  Label_DocFN.Caption:=fnDoc;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  if not VarIsEmpty(vDoc) then begin
     //   "" - /   MS Word (   /)
     Word_ActiveDoc_Close(vWord, true);
     vDoc := UnAssigned;
  end;
  fnDoc:='';
  Label_DocFN.Caption:=fnDoc;
  vDoc := Word_Doc_Add(vWord);
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
  if not VarIsEmpty(vWord) then begin
     OpenDialog1.InitialDir:=ExtractFilePath(fnDoc);
     OpenDialog1.FileName:=fnDoc;
     if OpenDialog1.Execute then begin
        fnDoc:=OpenDialog1.FileName;
        Label_DocFN.Caption:=fnDoc;
        vDoc := Word_Doc_Load(vWord, fnDoc);
     end;
  end;
end;



procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
  if FileExists(fnDoc) then begin
     if Word_Doc_Save(vDoc) then begin
        ShowMessage('Ok');
     end
     else begin
        ShowMessage('');
     end;
  end
  else begin
     ShowMessage('   ');
  end;
end;

procedure TForm1.SpeedButton6Click(Sender: TObject);
begin
  if not VarIsEmpty(vDoc) then begin
     fnDoc:=trim(fnDoc);
     if FileExists(fnDoc) then begin
        SaveDialog1.InitialDir:=ExtractFilePath(fnDoc);
     end
     else begin
        if fnDoc='' then fnDoc:=ExtractFilePath(ParamStr(0))+'abc';
        SaveDialog1.InitialDir:=ExtractFilePath(ParamStr(0));
     end;
     ShowMessage(SaveDialog1.InitialDir);
     SaveDialog1.FileName:='';
     if SaveDialog1.Execute then begin
        //if AnsiUpperCase(fnDoc)<>AnsiUpperCase(SaveDialog1.FileName) then begin
           fnDoc:=SaveDialog1.FileName;
           Label_DocFN.Caption:=fnDoc;
           if Word_Doc_SaveAs(vDoc, fnDoc, true) then begin
              ShowMessage('Ok');
           end
           else begin
              ShowMessage('');
           end;
        //end
        //else begin
        //   ShowMessage('!     ');
        //end;
     end;
  end;
end;

procedure TForm1.SpeedButton7Click(Sender: TObject);
Var
  iFormatDoc:integer;
  YesNext:boolean;
begin
  if not VarIsEmpty(vDoc) then begin
     YesNext:=false;
     iFormatDoc := wdFormatDocumentDefault;
     if RadioGroup_FormatDoc.ItemIndex=1 then iFormatDoc := wdFormatPDF;
     if RadioGroup_FormatDoc.ItemIndex=2 then iFormatDoc := wdFormatRTF;
     if RadioGroup_FormatDoc.ItemIndex=3 then iFormatDoc := wdFormatHTML;
     if RadioGroup_FormatDoc.ItemIndex=4 then iFormatDoc := wdFormatXML;
     if iFormatDoc = wdFormatDocumentDefault then begin
        SaveDialog1.InitialDir:=ExtractFilePath(fnDoc);
        SaveDialog1.FileName:='';
        if SaveDialog1.Execute then begin
           //if AnsiUpperCase(fnDoc)<>AnsiUpperCase(SaveDialog1.FileName) then begin
              YesNext:=true;
              fnDoc:=SaveDialog1.FileName;
              Label_DocFN.Caption:=fnDoc;
           //end
           //else begin
           //   ShowMessage('!     ');
           //end;
        end;
     end;
     if not YesNext then begin
        if FileExists(fnDoc) then begin
           YesNext:=true;
           if iFormatDoc = wdFormatPDF then fnDoc := ChangeFileExt(fnDoc,'.pdf');
           if iFormatDoc = wdFormatRTF then fnDoc := ChangeFileExt(fnDoc,'.rtf');
           if iFormatDoc = wdFormatHTML then fnDoc := ChangeFileExt(fnDoc,'.htm');
           if iFormatDoc = wdFormatXML then fnDoc := ChangeFileExt(fnDoc,'.xml');
           Label_DocFN.Caption:=fnDoc;
        end
        else begin
           ShowMessage('!       ');
        end;
     end;
     if YesNext then begin
        if Word_Doc_SaveAs_Ext(vDoc, fnDoc, iFormatDoc, false) then begin
           ShowMessage('Ok');
        end
        else begin
           ShowMessage('');
        end;
     end;
  end;
end;


procedure TForm1.SpeedButton8Click(Sender: TObject);
begin
  if Word_Doc_Print(vDoc) then begin
     ShowMessage('Ok');
  end
  else begin
     ShowMessage('');
  end;

end;

procedure TForm1.SpeedButton9Click(Sender: TObject);
begin
  if not VarIsEmpty(vDoc) then begin
     //   "" - /   MS Word (   /)
     Word_ActiveDoc_Close(vWord, true);
     vDoc := UnAssigned;
  end;
  fnDoc:='';
  Label_DocFN.Caption:=fnDoc;
end;

end.



